// command line to compile:
// sdcc -mz180 --data-loc0xFFD0 --code-loc0x0000 --no-std-crt0 simple.c
#include <z8s180.h>

void main()
{ 
 char status0;
 char rdata0;

   OMCR    = 0;      // OPERATION MODE CONTROL REGISTER IS SET TO 0
   RCR     = 0;      // 0 dissables refresh FOR STATIC RAM: reset value = 1
   CCR     = 0;      // CLOCK DIVIDED BY 0 = 0x80 divided by 2 = 0x00

   CNTLA0  = 0X74;   // 0111 0100  RE(6) = 1, TE(5) = 1, rts0(4) = 1, 8n1(2) = 1 
   status0 = STAT0;  // read status control register 05H - read DCD0 pin to enable receive
   
   ASEXT0  = 0x68;   // 0110 1000 - disable DCD0(6) and CTS0(5); X1(4) = 0; BRG0(3) Mode = 1
   CNTLB0  = 0x00;   // 0000 0000 - prescale 10 PS(5) = 0, DR(3) = 0, 
                                                  //     phi = 16,500,000
   ASTC0L  = 0x07;   // 0x1AC = 428 =   1200 baud: TC = phi / (2 x   2400 x 16) -2 
   ASTC0H  = 0x00;   // 0xD5  = 213 =   2400 baud: TC = phi / (2 x   4800 x 16) -2
                     // 0x69  = 105 =   4800 baud: TC = phi / (2 x   9600 x 16) -2 
                     // 0x34  =  52 =   9600 baud: TC = phi / (2 x  19200 x 16) -2 
                     // 0x10  =  16 =  19200 baud: TC = phi / (2 x  57600 x 16) -2 
                     // 0x07  =   7 =  57600 baud: TC = phi / (2 x 115200 x 16) -2  

while(1)
   {
   CNTLA0 = 0x7C;   // 0111 0100    
 
   if( (STAT0 & 0x80 ) == 0x80)
      {  
      rdata0 = RDR0;
      TDR0 = rdata0;
      TDR1 = rdata0;
      }
   }
} // end main
